<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJPSOAP_OrderedPrice2 ArrayType
 * @subpackage Arrays
 */
class ArrayOfJPSOAP_OrderedPrice2 extends AbstractStructArrayBase
{
    /**
     * The ChildrenB
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JPSOAP_OrderedPrice[]
     */
    public $ChildrenB;
    /**
     * Constructor method for ArrayOfJPSOAP_OrderedPrice2
     * @uses ArrayOfJPSOAP_OrderedPrice2::setChildrenB()
     * @param \StructType\JPSOAP_OrderedPrice[] $childrenB
     */
    public function __construct(array $childrenB = array())
    {
        $this
            ->setChildrenB($childrenB);
    }
    /**
     * Get ChildrenB value
     * @return \StructType\JPSOAP_OrderedPrice[]|null
     */
    public function getChildrenB()
    {
        return $this->ChildrenB;
    }
    /**
     * This method is responsible for validating the values passed to the setChildrenB method
     * This method is willingly generated in order to preserve the one-line inline validation within the setChildrenB method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateChildrenBForArrayConstraintsFromSetChildrenB(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJPSOAP_OrderedPrice2ChildrenBItem) {
            // validation for constraint: itemType
            if (!$arrayOfJPSOAP_OrderedPrice2ChildrenBItem instanceof \StructType\JPSOAP_OrderedPrice) {
                $invalidValues[] = is_object($arrayOfJPSOAP_OrderedPrice2ChildrenBItem) ? get_class($arrayOfJPSOAP_OrderedPrice2ChildrenBItem) : sprintf('%s(%s)', gettype($arrayOfJPSOAP_OrderedPrice2ChildrenBItem), var_export($arrayOfJPSOAP_OrderedPrice2ChildrenBItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ChildrenB property can only contain items of type \StructType\JPSOAP_OrderedPrice, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ChildrenB value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_OrderedPrice[] $childrenB
     * @return \ArrayType\ArrayOfJPSOAP_OrderedPrice2
     */
    public function setChildrenB(array $childrenB = array())
    {
        // validation for constraint: array
        if ('' !== ($childrenBArrayErrorMessage = self::validateChildrenBForArrayConstraintsFromSetChildrenB($childrenB))) {
            throw new \InvalidArgumentException($childrenBArrayErrorMessage, __LINE__);
        }
        $this->ChildrenB = $childrenB;
        return $this;
    }
    /**
     * Add item to ChildrenB value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_OrderedPrice $item
     * @return \ArrayType\ArrayOfJPSOAP_OrderedPrice2
     */
    public function addToChildrenB(\StructType\JPSOAP_OrderedPrice $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JPSOAP_OrderedPrice) {
            throw new \InvalidArgumentException(sprintf('The ChildrenB property can only contain items of type \StructType\JPSOAP_OrderedPrice, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ChildrenB[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JPSOAP_OrderedPrice|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JPSOAP_OrderedPrice|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JPSOAP_OrderedPrice|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JPSOAP_OrderedPrice|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JPSOAP_OrderedPrice|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ChildrenB
     */
    public function getAttributeName()
    {
        return 'ChildrenB';
    }
}
